/*
tmphsh.c Version 0.2.0  Hash build test database
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* Usage: tmphsh filename */

#include <bthash.h>

#define MAXLMT 999999

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage:   %s "
      "#records\n", pgm);
   fprintf(stderr,"Example: %s 100\n", pgm);
   fprintf(stderr,"#records is 1 - %d\n",
      MAXLMT);
   exit(1);
   } /* putstx */

int main(argc,argv)
int argc;
char **argv;
   {
   int opnerr;
   int i;
   int rslt;
   int lmt;
   int position;
   hashfmt *hshhdr;
   unsigned char *rndSeed;
   unsigned char *p,*q;
   unsigned char str[4096];
   if (argc != 2) putstx(*argv);
   lmt = (int) atoi(*(argv+1));
   if (lmt < 1 || lmt > MAXLMT) putstx(*argv);

   rndSeed = (unsigned char *) rndinit();
   if (rndSeed == NULL)
      {
      fprintf(stderr,"tmphsh: rndinit error\n");
      exit(1);
      } /* rndinit err */

   /* hopent numeric parameters */
   /* totrcds, rcdlen, keylen, keyofst */
   hshhdr = (hashfmt *) hopent(31,16,8,4,&opnerr,rndSeed);
   if (hshhdr == NULL)
      {
      fprintf(stderr,"tmphsh: open "
	 "error %d\n", opnerr);
      free(rndSeed);
      exit(1);
      } /* open error */
   /* process starts here */

   rslt = 0;
   i = lmt;
   while (!rslt && (i--))
      {
      p = (unsigned char *) str;
      q = (unsigned char *) p + hshhdr->keyofst;
      while (p < q)
	 {
	 *p++ = rndnum(26,rndSeed) + 'a';
	 } /* for each char in rcd */
      q = (unsigned char *) p + hshhdr->keylen;
      while (p < q)
	 {
	 *p++ = rndnum(26,rndSeed) + 'A';
	 } /* for each char in rcd */
      q = (unsigned char *) str + hshhdr->rcdlen;
      while (p < q)
	 {
	 *p++ = rndnum(26,rndSeed) + 'a';
	 } /* for each char in rcd */
      *p = '\0';
      rslt = hisrt(hshhdr,str);
      if (rslt)
	 {
	 fprintf(stderr,"tmphsh: after hisrt rslt %d\n",
	    rslt);
	 exit(1);
	 } /* hisrt err */
      } /* insert loop */

   printf("tmphsh: temporary database %s\n",
      hshhdr->dbname);
   position = SWPFRST;
   rslt = 0;
   while (!rslt)
      {
      rslt = hsweep(hshhdr,position,NULL);
      if (rslt) break;
      printf("%9d.  %08x  %08x  ",
	 hshhdr->seq,
	 (unsigned int) hshhdr->hashofst,
	 (unsigned int) hshhdr->ofst);
      p = (unsigned char *) hshhdr->rcd;
      q = (unsigned char *) p + hshhdr->rcdlen;
      while (p < q) putchar(*p++);
      putchar('\n');
      position = SWPNEXT;
      } /* print each record in hash sequence */
   
   rslt = hdbck(hshhdr);
   if (rslt || hshhdr->reason)
      {
      fprintf(stderr,"tmphsh: error in hdbck\n");
      fprintf(stderr,"tmphsh: rslt %d reason %d\n",
	 rslt, hshhdr->reason);
      } /* if dbck err */

   /**********************************************************/
   /* piping the output will prevent the */
   /* temporary file from being removed */
   hcloset(hshhdr);
   return(0);
   } /* main */
